/****************************************************************
 * LineBuffer.cc : Block -> Line buffering
 *
 * (c) 1997 Yutaka Oiwa.
 *
 * $Id: LineBuffer.cc,v 1.1 1997/12/27 19:06:54 yutaka Exp $
 ****************************************************************/

#include "LineBuffer.h"
#include <string.h>

void LineBuffer::put(char *data, int len)
{
  if (len > 0) {
    if(buf_len + len >= MAXSIZE) {
      memmove(buf, buf + read, buf_len - read);
      buf_len -= read;
      read = 0;
    }
    if(buf_len + len >= MAXSIZE) {
      len = MAXSIZE - buf_len;
    }
    memmove(buf+buf_len, data, len);
    buf_len += len;
  }
  while(buf_len > read) {
    char *p = (char *)memchr(buf + read, '\n', buf_len - read);
    if (p) {
      *p = '\0';
      callback(app_data, buf+read, p-buf-read);
      read = p - buf + 1;
    } else
      break;
  }
  if (len == 0) {
    if (buf_len != read)
      callback(app_data, buf+read, buf_len - read);
    callback(app_data, NULL, -1);
  }
}

   
